[![SmarkForm Logo](docs/assets/SmarkForm_logo.png)](https://www.npmjs.com/package/smarkform)

<details>
<summary>Powerful while effortless Markup-driven and Extendable forms.</summary>

SmarkForm is a powerful library for creating markup-driven and extendable forms
in web applications.

SmarkForm empowers designers to enhance their form templates with
advanced capabilities, such as dynamic list manipulation and context-based
interactions, with no need to deal with complex JavaScript code.

</details>

[![NPM Version][npm-image]][npm-url]
[![npm dependencies][dependencies-image]][dependencies-url]
[![NPM Downloads][downloads-image]][downloads-url]
[![jsDelivr Hits][cdnhits-image]][cdnhits-url]
[![License][license-image]][license-url]
<!-- Hilighting fix: []() -->

<a href="https://smarkform.bitifet.net">
<img align="right" alt="Reference Manual" src="docs/assets/ReferenceManual.png" />
</a>


## Features

  * Easy to use **Markup-driven** and Intuitive API.
  * **Responsive and accessible UX** across devices.
  * **Imports/Exports JSON** supporting nested subforms (objects) and
    variable-length lists (arrays).
  * Configurable context-driven keyboard shortcuts (hotkeys).
  * No reliance on a specific HTML structure: **Designers have complete freedom**.
  * **No manual wiring** between controls and fields.
  * Lightweight (**Only ~35KB** minified), flexible and extendable.
  * [More...](https://smarkform.bitifet.net/about/features)


## Installation

  * As NPM package: `npm install smarkform`.

  * Alternatively you can get SmarkForm through [several other resources such
    as CDN and
    more...](https://smarkform.bitifet.net/getting_started/getting_smarkform)

## Usage

For detailed usage instructions and API reference check out [📔 SmarkForm
Reference Manual](https://smarkform.bitifet.net).


## Try it yourself!!

  * See our [Live Examples](https://smarkform.bitifet.net/resources/examples).
    - You can download each one and modify as you like.

  * See also interactive code snippets across the [Reference Manual](https://smarkform.bitifet.net).
    - They show relevant HTML, JS (and sometimes CSS).
    - Try them out in the *Preview* tab.
    - Don't miss the *Notes* tabs for relevant insights.


## Contributing

Contributions are welcome! If you find any issues or have suggestions for improvements, please open an issue or submit a pull request.

Before contributing, make sure to read our [contribution guidelines](https://smarkform.bitifet.net/community/contributing).


## Documentation

You can find official *SmarkForm* documentation at:

  👉 [https://smarkform.bitifet.net](https://smarkform.bitifet.net)


### Documentation Source:

Documentation source can be found in [/docs](/docs) directory of this
repository.

It uses [Jekyll](https://jekyllrb.com/) and
[just-the-docs](https://just-the-docs.github.io/just-the-docs/) Jekyll layout
and it is automatically deployed by GitHub infrastructure anytime new revision
is pushed..


### Documentation Building:

To build SmarkForm documentation localloy you first need to install follow this
instructions:

  * [Install Jekyll prerequisites](https://jekyllrb.com/docs/installation/)

  * Execute `gem install jekyll bundler`.

  * Run `npm run doc`.

Then you will be able to see the documentation at `http://localhost:4000` or
`http://<your-ip>:4000`.


## License

  [MIT](LICENSE)


# Acknowledgements

We would like to express our gratitude to the open source community for their valuable contributions and feedback.


[npm-image]: https://img.shields.io/npm/v/smarkform.svg
[npm-url]: https://npmjs.org/package/smarkform
[dependencies-image]: https://img.shields.io/badge/dependencies-0-green
[dependencies-url]: https://www.npmjs.com/package/smarkform?activeTab=dependencies
[downloads-image]: https://img.shields.io/npm/dm/smarkform.svg
[downloads-url]: https://npmjs.org/package/smarkform
[cdnhits-image]: https://data.jsdelivr.com/v1/package/npm/smarkform/badge?style=rounded
[cdnhits-url]: https://www.jsdelivr.com/package/npm/smarkform
[license-image]: https://img.shields.io/badge/license-MIT-brightgreen.svg
[license-url]: https://opensource.org/licenses/MIT

